// BigScrl.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "BigScrl.h"

#include "MainFrm.h"

#include "ChildFrm.h"
#include "BigDoc.h"
#include "BigView.h"
#include "AppView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBigScrollApp helpers

void GetPrinterPageSize(CSize &pageSize)
{
	CPrintInfo PrintInfo;
	pageSize = CSize(2100, 2960);		// default to A4
	if (AfxGetApp()->GetPrinterDeviceDefaults(&PrintInfo.m_pPD->m_pd))
	{
		if (PrintInfo.m_pPD->CreatePrinterDC() != NULL)
		{
			if (PrintInfo.m_pPD->m_pd.hDC == NULL)
				PrintInfo.m_pPD->CreatePrinterDC();
		
			// attach printer dc and retreive docSize
			CDC dcPrint;
			dcPrint.Attach(PrintInfo.m_pPD->m_pd.hDC);
			pageSize.cx = 10 * dcPrint.GetDeviceCaps(HORZSIZE);
			pageSize.cy = 10 * dcPrint.GetDeviceCaps(VERTSIZE);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CBigScrollApp

BEGIN_MESSAGE_MAP(CBigScrollApp, CWinApp)
	//{{AFX_MSG_MAP(CBigScrollApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBigScrollApp construction

CBigScrollApp::CBigScrollApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CBigScrollApp object

CBigScrollApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CBigScrollApp initialization

BOOL CBigScrollApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_BIGSCRTYPE,
		RUNTIME_CLASS(CBigScrollDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CAppScrollView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}

void CBigScrollApp::OnFilePrintSetup()
{
	CWinApp::OnFilePrintSetup();

	// notify all documents
	POSITION TempPos = GetFirstDocTemplatePosition();
	while (TempPos)
	{
		CDocTemplate *pTemplate = GetNextDocTemplate(TempPos);
		if (pTemplate)
		{
			POSITION DocPos = pTemplate->GetFirstDocPosition();
			while (DocPos)
			{
				CDocument *pDoc = pTemplate->GetNextDoc(DocPos);
				pDoc->OnCmdMsg(ID_PRINTER_CHANGED, 0, NULL, NULL);
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CBigScrollApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CBigScrollApp commands
